/*-------------------------------------------------------------------------------------------------\
| Misc CAN Node Firmware
|
| File:					MSC.H			Header File
|
| Global Routines:	None
|
| Local Routines:		None
\-------------------------------------------------------------------------------------------------*/


//-------------------------------------------------------------------------------------------------
//  Global #defines
//-------------------------------------------------------------------------------------------------

#define	TRUE	1
#define	FALSE	0

#define	TXQUEUELENGTH	8			// Length of the Transmit Message Queue: 45 bytes = 15 queued messages

#define	INT_PIN			RB0		// INT = Interrupt in

#define	STATUSLEDS					// Define all of the status LEDs
#define	ERROR_LED		RA0			// RED
#define	OVERFLOW_LED	RA1			// YELLOW
#define	CANERR_LED		RA2			// YELLOW
#define	BUSERR_LED		RA3			// YELLOW
#define	GREEN1_LED		RA4			//
#          define	GREEN2_LED		RA5			// 
#define	LED_ON			0
#define	LED_OFF			1

//-------------------------------------------------------------------------------------------------
//  Define Structs
//-------------------------------------------------------------------------------------------------

struct message
{
	char	cFrameInfo;
	char	cMsgID1;
	char	cMsgID2;
	char	cData[8];
};

//-------------------------------------------------------------------------------------------------
//  Global Function Declarations
//-------------------------------------------------------------------------------------------------

	void					Initialize			(void);
	void					Init_SJA 			(void);
	
	void	interrupt	ISR					(void);	// Note: "interrupt" is a PICC keyword

	void					Read_SJA_Regs		(void);

	void					ServiceSJA			(void);
	void					GetMessage			(void);
	void					SendMessage			(void);
	void 					LoadTxQueue 		(struct message mMessage);
	void					ButtonPushed		(void);
	void 					SendCount			(void);

//-------------------------------------------------------------------------------------------------
//  Global Variables Declarations
//-------------------------------------------------------------------------------------------------

	extern	bit						gbPowerUp;
	extern	char						gcSystemError;

	extern	bit						gbOneMs;
	extern	bit						gbHundredMs;
	extern	bit						gbOneSec;
	extern	bit						gbTenMs;

	
	extern	bit						gbSJAInterrupt;
	extern	bit						gbTxReady;
	extern	bit						gbRxReady;

	extern	char						gcTxQueueOut;
	extern	char						gcTxQueueIn;
	extern bank2 struct message 	gmTransmitQueue[TXQUEUELENGTH];

	extern	struct message			gmMessage;
	
	extern	bank3 char				cSJARegisters[32];

	extern	char						gcErrArray[8];
	extern	char						gcErrIndex;

//-------------------------------------------------------------------------------------------------
//  Define Macros
//-------------------------------------------------------------------------------------------------

// None

	
